#include "vymview.h"

#include <iostream>

#include "mapeditor.h"

VymView::VymView(VymModel *model)
{
	// Create TreeView
	treeview=new QTreeView;
	treeview->setModel ((QAbstractItemModel*)model);
	treeview->setMinimumWidth (350);
	treeview->setColumnWidth (0,350);

	// ItemSelectionModel
	selModel=treeview->selectionModel();
	connect (
		selModel, SIGNAL (selectionChanged(const QItemSelection &, const QItemSelection &)), 
		this,SLOT (changeSelection(const QItemSelection &,const QItemSelection &)));
	model->setSelectionModel (selModel);

	// Create good old MapEditor
	MapEditor* me=model->getMapEditor();
	if (!me) me=new MapEditor (model);

	me->setSelectionModel (selModel);

	//me->viewport()->setFocus();
	//FIXME me->setAntiAlias (actionViewToggleAntiAlias->isOn());
	//FIXME me->setSmoothPixmap(actionViewToggleSmoothPixmapTransform->isOn());

	addWidget (treeview);
	addWidget (me);

	// Set geometry
	QList <int> sizes;
	sizes.append (150);
	sizes.append (600);
	setSizes (sizes);
}

QItemSelectionModel* VymView::selectionModel() 
{
	if (treeview) return selModel;
	else std::cout <<"hey, no treeview so far???\n";
	return NULL;
}


void VymView::changeSelection (const QItemSelection &newSel, const QItemSelection &delSel)
{
	// FIXME Currently this works only from treeview->ME
	treeview->expandAll();	//FIXME only for testing

	((VymModel*)treeview->model())->select ();
}

